﻿import std.c.windows.windows;
import std.string;
import std.c.string;
import std.windows.charset;
import std.math;
import std.file;
import std.regexp;
import std.conv;
//

pragma(lib, "advapi32.lib");
pragma(lib, "shell32.lib");
pragma(lib, "gdi32.lib");
pragma(lib, "comdlg32.lib");
pragma(lib, "comctl32.lib");

const int TB_THUMBTRACK = 0x05;
const int WM_SETFONT = 0x30;
const int BUTTON_CLICK1 = 0x101;
const int BUTTON_CLICK2 = 0x102;
const int CHECK_CLICK1 = 0x103;
const int CHECK_CLICK2 = 0x104;
const int CHECK_CLICK3 = 0x105;
const int FONT_SELECT1 = 0x110;
const int FONT_SELECT2 = 0x111;
const int FONT_SELECT3 = 0x112;
const int FPS_SELECT = 0x120;
const int TBM_SETPOS = 0x405;
const int TBM_SETRANGEMIN = 0x407;
const int TBM_SETRANGEMAX = 0x408;

extern (C) void gc_init();
extern (C) void gc_term();
extern (C) void _minit();
extern (C) void _moduleCtor();
extern (C) void _moduleDtor();
extern (C) void _moduleUnitTests();

extern (C) void list_font(char*, HWND);

extern (Windows) HINSTANCE ShellExecuteA(HWND hwnd, char* lpVerb, char* lpFile, char* lpParameters, char* lpDirectory, int nShowCmd);

extern (Windows) int GetPrivateProfileIntA(char* lpAppName, char* lpKeyName, int nDefault, char* lpFileName);

extern (Windows) int GetPrivateProfileStringA(
char* lpAppName, char* lpKeyName, char* lpDefault, char* lpReturnedString, int nSize, char* lpFileName);

extern (Windows) bool WritePrivateProfileStringA(char* lpAppName, char* lpKeyName, char* lpString, char* lpFileName);

extern (Windows) int RegQueryValueExA(HKEY hKey, char* lpValueName, int* lpReserved, int* lpType, ubyte* lpData, int* lpcbData);

extern (Windows) bool ChooseFontA(CHOOSEFONTA* lpcf);

typedef uint function (HWND, uint, WPARAM, LPARAM) LPCFHOOKPROC;

struct CHOOSEFONTA {
  DWORD lStructSize;
  HWND hwndOwner;
  HDC hDC;
  LOGFONTA* lpLogFont;
  INT iPointSize;
  DWORD Flags;
  DWORD rgbColors;
  LPARAM lCustData;
  LPCFHOOKPROC lpfnHook;
  LPCSTR lpTemplateName;
  HINSTANCE hInstance;
  LPSTR lpszStyle;
  WORD nFontType;
  WORD MISSING_ALIGNMENT;
  INT nSizeMin;
  INT nSizeMax;
}

bool list_font(HWND handle){
  
  return(true);
}

char[] data_dir(){
  char[][] dirs;
  dirs = listdir(getcwd());
  char[] result;
  foreach(char[] str; dirs){
    if(isdir(str)){
      result = ".\\" ~ str ~ "\\";
      char[][] second_dir = listdir(result);
      foreach(char[] str2; second_dir){
        if(str2 == "Game.exe"){
          return(result);
        }
      }
      return("");
    }
  }
  return("");
}

char[] readme_file(){
  RegExp pattern = new RegExp("(read ?me|りーどみぃ|リードミィ)[.](txt|html?)", "i");
  char[] result = "";
  char[][] dirs = listdir(base_dir);
  foreach(char[] str; dirs){
    if(pattern.find(str) >= 0){
      result = (data_dir ~ str.dup);
      break;
    }
  }
  return(result);
}

extern (Windows)
void WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow){
  gc_init();  // GCを開始する
  _minit();  // モジュールを開始する
  _moduleCtor();  // モジュールを初期化する
  _moduleUnitTests();  // モジュールの単体テスト
  
  my_main(hInstance);
  
  _moduleDtor();  // モジュールの破棄
  
  gc_term();  // GCの終了
}

HWND fontname1;
HWND fontname2;
HWND fontname3;
HFONT bfont_handle1;
HFONT bfont_handle2;
HFONT bfont_handle3;
HWND select_bar1;
HWND select_bar2;
HWND fps_select1;
HWND fps_select2;
HWND fps_select3;
HWND fps_select4;
HWND fps_select5;
HWND volume_text1;
HWND volume_text2;

//
char[] base_dir;

extern (Windows)
void my_main(HINSTANCE inst){
  HWND handle;
  HWND button1;
  HWND button2;
  HWND check1;
  HWND check2;
  HWND check3;
  HWND fontset;
  HWND set_button1;
  HWND set_button2;
  HWND set_button3;
  HWND volumeset1;
  HWND volumeset2;
  HWND fpsset;
  
  char[][] names;
  
  MSG mess;
  HKEY key_handle;
  HFONT font_handle;
  
  ubyte data_value;
  int data_value2;
  int data_value3 = 256;
  //
  base_dir = data_dir();
  if(base_dir == ""){
    MessageBoxA(null, tosjisz("Game.exeが見つかりません"), tosjisz("404 Not Found"),  MB_OK | MB_ICONEXCLAMATION);
    return;
  }
  //
  names ~= read_ini(base_dir ~ "Game.ini", "User", "BaseFont1");
  names ~= read_ini(base_dir ~ "Game.ini", "User", "BaseFont2");
  names ~= read_ini(base_dir ~ "Game.ini", "User", "BaseFont3");
  //
  if(create_base_window(inst)){
    handle = CreateWindowExA(0, tosjisz("MainWindow"), toStringz(read_ini(base_dir ~ "Game.ini", "Game", "Title")), WS_DLGFRAME |WS_MINIMIZEBOX | WS_SYSMENU | WS_VISIBLE, CW_USEDEFAULT, CW_USEDEFAULT, 200, 400, cast(HWND)null, cast(HMENU)null, inst, null);
    //
    button1 = CreateWindowExA(0, tosjisz("BUTTON"), tosjisz("ゲーム開始"), WS_CHILD | WS_VISIBLE, 8, 6, 88, 20, handle, cast(HMENU)BUTTON_CLICK1, inst, null);
    //
    button2 = CreateWindowExA(0, tosjisz("BUTTON"), tosjisz("りーどみぃ"), WS_CHILD | WS_VISIBLE, 96, 6, 88, 20, handle, cast(HMENU)BUTTON_CLICK2, inst, null);
    //
    check1 = CreateWindowExA(0, tosjisz("BUTTON"), tosjisz("滑らかモード"), WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX | BS_LEFTTEXT, 16, 40, 160, 20, handle, cast(HMENU)CHECK_CLICK1, inst, null);
    //
    check2 = CreateWindowExA(0, tosjisz("BUTTON"), tosjisz("ちらつきを抑える"), WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX | BS_LEFTTEXT, 16, 64, 160, 20, handle, cast(HMENU)CHECK_CLICK2, inst, null);
    //
    check3 = CreateWindowExA(0, tosjisz("BUTTON"), tosjisz("フルスクリーン"), WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX | BS_LEFTTEXT, 16, 88, 160, 20, handle, cast(HMENU)CHECK_CLICK3, inst, null);
    //
    font_handle = CreateFontA(15, 0, 0, 0, 4, false, false, false, SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, tosjisz("ＭＳ 明朝"));
    bfont_handle1 = CreateFontA(15, 0, 0, 0, 4, false, false, false, SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, names[0].toStringz());
    bfont_handle2 = CreateFontA(15, 0, 0, 0, 4, false, false, false, SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, names[1].toStringz());
    bfont_handle3 = CreateFontA(15, 0, 0, 0, 4, false, false, false, SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, names[2].toStringz());
    //
    fontset = CreateWindowExA(0, tosjisz("STATIC"), tosjisz("フォントの選択"), WS_CHILD | WS_VISIBLE | SS_CENTER, 8, 120, 176, 16, handle, cast(HMENU)null, inst, null);
    //
    fontname1 = CreateWindowExA(0, tosjisz("STATIC"), toStringz(names[0]), WS_CHILD | WS_VISIBLE, 8, 152, 136, 16, handle, cast(HMENU)null, inst, null);
    //
    fontname2 = CreateWindowExA(0, tosjisz("STATIC"), toStringz(names[1]), WS_CHILD | WS_VISIBLE, 8, 176, 136, 16, handle, cast(HMENU)null, inst, null);
    //
    fontname3 = CreateWindowExA(0, tosjisz("STATIC"), toStringz(names[2]), WS_CHILD | WS_VISIBLE, 8, 200, 136, 16, handle, cast(HMENU)null, inst, null);
    //
    set_button1 = CreateWindowExA(0, tosjisz("BUTTON"), tosjisz("選択"), WS_CHILD | WS_VISIBLE, 144, 150, 40, 20, handle, cast(HMENU)FONT_SELECT1, inst, null);
    //
    set_button2 = CreateWindowExA(0, tosjisz("BUTTON"), tosjisz("選択"), WS_CHILD | WS_VISIBLE, 144, 174, 40, 20, handle, cast(HMENU)FONT_SELECT2, inst, null);
    //
    set_button3 = CreateWindowExA(0, tosjisz("BUTTON"), tosjisz("選択"), WS_CHILD | WS_VISIBLE, 144, 198, 40, 20, handle, cast(HMENU)FONT_SELECT3, inst, null);
    //
    volumeset1 = CreateWindowExA(0, tosjisz("STATIC"), tosjisz("音楽の音量調整"), WS_CHILD | WS_VISIBLE | SS_LEFT, 8, 232, 136, 16, handle, cast(HMENU)null, inst, null);
    //
    select_bar1 = CreateWindowExA(0, tosjisz("msctls_trackbar32"), null, WS_CHILD | WS_VISIBLE | 0x100, 0, 248, 192, 24, handle, cast(HMENU)null, inst, null);
    SendMessageA(select_bar1, TBM_SETRANGEMAX, 0, 100);
    SendMessageA(select_bar1, TBM_SETRANGEMIN, 0, 0);
    SendMessageA(select_bar1, TBM_SETPOS, 1, read_ini(base_dir ~ "Game.ini", "User", "MusicVolume").toInt());
    //
    volume_text1 = CreateWindowExA(0, tosjisz("STATIC"), tosjisz(read_ini(base_dir ~ "Game.ini", "User", "MusicVolume")), WS_CHILD | WS_VISIBLE | SS_LEFT, 160, 232, 24, 16, handle, cast(HMENU)null, inst, null);
    //
    volumeset2 = CreateWindowExA(0, tosjisz("STATIC"), tosjisz("効果音の音量調整"), WS_CHILD | WS_VISIBLE | SS_LEFT, 8, 280, 136, 16, handle, cast(HMENU)null, inst, null);
    //
    select_bar2 = CreateWindowExA(0, tosjisz("msctls_trackbar32"), null, WS_CHILD | WS_VISIBLE | 0x100, 0, 296, 192, 24, handle, cast(HMENU)null, inst, null);
    SendMessageA(select_bar2, TBM_SETRANGEMAX, 0, 100);
    SendMessageA(select_bar2, TBM_SETRANGEMIN, 0, 0);
    SendMessageA(select_bar2, TBM_SETPOS, 1, read_ini(base_dir ~ "Game.ini", "User", "SoundVolume").toInt());
     //
    volume_text2 = CreateWindowExA(0, tosjisz("STATIC"), tosjisz(read_ini(base_dir ~ "Game.ini", "User", "SoundVolume")), WS_CHILD | WS_VISIBLE | SS_LEFT, 160, 280, 24, 16, handle, cast(HMENU)null, inst, null);
    //
    fpsset = CreateWindowExA(0, tosjisz("STATIC"), tosjisz("FPSの調整"), WS_CHILD | WS_VISIBLE | SS_CENTER, 8, 324, 176, 16, handle, cast(HMENU)null, inst, null);
    //
    fps_select1 = CreateWindowExA(0, tosjisz("BUTTON"), tosjisz("20"), WS_CHILD | WS_VISIBLE | WS_GROUP | BS_AUTORADIOBUTTON, 16, 344, 32, 16, handle, cast(HMENU)FPS_SELECT, inst, null);
    fps_select2 = CreateWindowExA(0, tosjisz("BUTTON"), tosjisz("30"), WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON, 48, 344, 32, 16, handle, cast(HMENU)FPS_SELECT, inst, null);
    fps_select3 = CreateWindowExA(0, tosjisz("BUTTON"), tosjisz("40"), WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON, 80, 344, 32, 16, handle, cast(HMENU)FPS_SELECT, inst, null);
    fps_select4 = CreateWindowExA(0, tosjisz("BUTTON"), tosjisz("50"), WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON, 112, 344, 32, 16, handle, cast(HMENU)FPS_SELECT, inst, null);
    fps_select5 = CreateWindowExA(0, tosjisz("BUTTON"), tosjisz("60"), WS_CHILD | WS_VISIBLE |BS_AUTORADIOBUTTON, 144, 344, 32, 16, handle, cast(HMENU)FPS_SELECT, inst, null);
    //
    switch(read_ini(base_dir ~ "Game.ini", "User", "BaseFPS", "40")){
      case "20":{
        SendMessageA(fps_select1, BM_SETCHECK, 1, 0);
        break;
      }
      case "30":{
        SendMessageA(fps_select2, BM_SETCHECK, 1, 0);
        break;
      }
      case "40":{
        SendMessageA(fps_select3, BM_SETCHECK, 1, 0);
        break;
      }
      case "50":{
        SendMessageA(fps_select4, BM_SETCHECK, 1, 0);
        break;
      }
      case "60":{
        SendMessageA(fps_select5, BM_SETCHECK, 1, 0);
        break;
      }
      default:{
        SendMessageA(fps_select3, BM_SETCHECK, 1, 0);
        break;
      }
    }
    //
    SendMessageA(button1, WM_SETFONT, cast(int)font_handle, 1);
    SendMessageA(button2, WM_SETFONT, cast(int)font_handle, 1);
    SendMessageA(check1, WM_SETFONT, cast(int)font_handle, 1);
    SendMessageA(check2, WM_SETFONT, cast(int)font_handle, 1);
    SendMessageA(check3, WM_SETFONT, cast(int)font_handle, 1);
    SendMessageA(fontset, WM_SETFONT, cast(int)font_handle, 1);
    SendMessageA(fontname1, WM_SETFONT, cast(int)bfont_handle1, 1);
    SendMessageA(fontname2, WM_SETFONT, cast(int)bfont_handle2, 1);
    SendMessageA(fontname3, WM_SETFONT, cast(int)bfont_handle3, 1);
    SendMessageA(set_button1, WM_SETFONT, cast(int)font_handle, 1);
    SendMessageA(set_button2, WM_SETFONT, cast(int)font_handle, 1);
    SendMessageA(set_button3, WM_SETFONT, cast(int)font_handle, 1);
    SendMessageA(volumeset1, WM_SETFONT, cast(int)font_handle, 1);
    SendMessageA(volumeset2, WM_SETFONT, cast(int)font_handle, 1);
    SendMessageA(volume_text1, WM_SETFONT, cast(int)font_handle, 1);
    SendMessageA(volume_text2, WM_SETFONT, cast(int)font_handle, 1);
    SendMessageA(fpsset, WM_SETFONT, cast(int)font_handle, 1);
    SendMessageA(fps_select1, WM_SETFONT, cast(int)font_handle, 1);
    SendMessageA(fps_select2, WM_SETFONT, cast(int)font_handle, 1);
    SendMessageA(fps_select3, WM_SETFONT, cast(int)font_handle, 1);
    SendMessageA(fps_select4, WM_SETFONT, cast(int)font_handle, 1);
    SendMessageA(fps_select5, WM_SETFONT, cast(int)font_handle, 1);
    //
    if(RegOpenKeyExA(HKEY_CURRENT_USER, tosjisz("Software\\Enterbrain\\RGSS"), 0, KEY_ALL_ACCESS, &key_handle) == 0){
      RegQueryValueExA(key_handle, tosjisz("SmoothMode"), null, &data_value2, &data_value, &data_value3);
      if(data_value != 0){SendMessageA(check1, BM_SETCHECK, 1, 0);}
      RegQueryValueExA(key_handle, tosjisz("WaitForVsync"), null, &data_value2, &data_value, &data_value3);
      if(data_value != 0){SendMessageA(check2, BM_SETCHECK, 1, 0);}
    }
    RegCloseKey(key_handle);
    if(read_ini(base_dir ~ "Game.ini", "User", "FullScreen", "0") == "1"){
      SendMessageA(check3, BM_SETCHECK, 1, 0);
    }
  }
  //
  ShowWindow(handle, SW_SHOWNORMAL);
  while (GetMessageA(&mess, cast(HWND)null, 0, 0)){
    TranslateMessage(&mess);
    DispatchMessageA(&mess);
  }
}

CHOOSEFONTA create_logfont(HWND hwnd, LOGFONTA* owner){
  CHOOSEFONTA cf;
  cf.lStructSize = cast(uint)CHOOSEFONTA.sizeof;
  cf.hwndOwner = hwnd;
  cf.lpLogFont = owner;
  cf.Flags = 0x1000001;
  return cf;
}

extern(Windows)
int base_window_proc(HWND handle, uint mess, WPARAM wparam, LPARAM lparam){
  CHOOSEFONTA cf;
  LOGFONTA lf;
  cf = create_logfont(handle, &lf);
  switch(mess){
  case WM_COMMAND:{
    switch(cast(int)wparam){
    case BUTTON_CLICK1:{
      ShellExecuteA(null, null, tosjisz(data_dir() ~ "Game.exe"), null, tosjisz(getcwd()), 5);
      PostQuitMessage(0);
      break;
    }
    case BUTTON_CLICK2:{
      char[] file = readme_file();
      if(file != ""){
        ShellExecuteA(null, null, tosjisz(file), null, tosjisz(getcwd()), 5);
      }
      break;
    }
    case CHECK_CLICK1:{
      HKEY key_handle;
      ubyte data_value;
      int data_value3 = 4;
      if(RegOpenKeyExA(HKEY_CURRENT_USER, tosjisz("Software\\Enterbrain\\RGSS"), 0, KEY_ALL_ACCESS, &key_handle) == 0){
        RegQueryValueExA(key_handle, tosjisz("SmoothMode"), null, null, &data_value, &data_value3);
        if(data_value == 0){
          data_value = 1;
        }else{
          data_value = 0;
        }
        RegSetValueExA(key_handle, tosjisz("SmoothMode"), 0, REG_DWORD, &data_value, 4);
        RegCloseKey(key_handle);
      }
      break;
    }
    case CHECK_CLICK2:{
      HKEY key_handle;
      ubyte data_value;
      int data_value3 = 4;
      if(RegOpenKeyExA(HKEY_CURRENT_USER, tosjisz("Software\\Enterbrain\\RGSS"), 0, KEY_ALL_ACCESS, &key_handle) == 0){
        RegQueryValueExA(key_handle, tosjisz("WaitForVsync"), null, null, &data_value, &data_value3);
        if(data_value == 0){
          data_value = 1;
        }else{
          data_value = 0;
        }
        RegSetValueExA(key_handle, tosjisz("WaitForVsync"), 0, REG_DWORD, &data_value, 4);
        RegCloseKey(key_handle);
      }
      break;
    }
    case CHECK_CLICK3:{
      if(read_ini(base_dir ~ "Game.ini", "User", "FullScreen", "0") == "0"){
        write_ini(base_dir ~ "Game.ini", "User", "FullScreen", "1");
      }else{
        write_ini(base_dir ~ "Game.ini", "User", "FullScreen", "0");
      }
      break;
    }
    case FONT_SELECT1:{
      int selected = ChooseFontA(&cf);
      if(selected != 0){
        write_ini(base_dir ~ "Game.ini", "User", "BaseFont1", toString(lf.lfFaceName.toutfz()));
        bfont_handle1 = CreateFontA(15, 0, 0, 0, 4, false, false, false, SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, lf.lfFaceName.toStringz());
        SendMessageA(fontname1, WM_SETFONT, cast(int)bfont_handle1, 1);
        SendMessageA(fontname1, WM_SETTEXT, 0, cast(int)(lf.lfFaceName.toStringz()));
      }
      break;
    }
    case FONT_SELECT2:{
      int selected = ChooseFontA(&cf);
      if(selected != 0){
        write_ini(base_dir ~ "Game.ini", "User", "BaseFont2", toString(lf.lfFaceName.toutfz()));
        bfont_handle2 = CreateFontA(15, 0, 0, 0, 4, false, false, false, SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, lf.lfFaceName.toStringz());
        SendMessageA(fontname2, WM_SETFONT, cast(int)bfont_handle2, 1);
        SendMessageA(fontname2, WM_SETTEXT, 0, cast(int)(lf.lfFaceName.toStringz()));
      }
      break;
    }
    case FONT_SELECT3:{
      int selected = ChooseFontA(&cf);
      if(selected != 0){
        write_ini(base_dir ~ "Game.ini", "User", "BaseFont3", toString(lf.lfFaceName.toutfz()));
        bfont_handle3 = CreateFontA(15, 0, 0, 0, 4, false, false, false, SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, lf.lfFaceName.toStringz());
        SendMessageA(fontname3, WM_SETFONT, cast(int)bfont_handle3, 1);
        SendMessageA(fontname3, WM_SETTEXT, 0, cast(int)(lf.lfFaceName.toStringz()));
      }
      break;
    }
    case FPS_SELECT:{
      if(cast(HWND)lparam == fps_select1){
        write_ini(base_dir ~ "Game.ini", "User", "BaseFPS", "20");
      }
      if(cast(HWND)lparam == fps_select2){
        write_ini(base_dir ~ "Game.ini", "User", "BaseFPS", "30");
      }
      if(cast(HWND)lparam == fps_select3){
        write_ini(base_dir ~ "Game.ini", "User", "BaseFPS", "40");
      }
      if(cast(HWND)lparam == fps_select4){
        write_ini(base_dir ~ "Game.ini", "User", "BaseFPS", "50");
      }
      if(cast(HWND)lparam == fps_select5){
        write_ini(base_dir ~ "Game.ini", "User", "BaseFPS", "60");
      }
      break;
    }
    default:
      break;
    }
    break;
  }
  case WM_PAINT:{
    break;
  }
  case WM_HSCROLL:{
    if(cast(int)remainder(cast(real)wparam, cast(real)65536) == TB_THUMBTRACK){
      if(cast(HWND)lparam == select_bar1){
        write_ini(base_dir ~ "Game.ini", "User", "MusicVolume", toString(wparam / 65536));
        SendMessageA(volume_text1, WM_SETTEXT, 0, cast(int)(toString(wparam / 65536).toStringz()));
      }
      if(cast(HWND)lparam == select_bar2){
        write_ini(base_dir ~ "Game.ini", "User", "SoundVolume", toString(wparam / 65536));
        SendMessageA(volume_text2, WM_SETTEXT, 0, cast(int)(toString(wparam / 65536).toStringz()));
      }
    }
    break;
  }
  case WM_DESTROY:{
    PostQuitMessage(0);
    break;
  }
  default:
    break;
  }
  return DefWindowProcA(handle, mess, wparam, lparam);
}

int create_base_window(HINSTANCE inst){
  WNDCLASS window_base;
  window_base.style = CS_HREDRAW | CS_VREDRAW;
  window_base.lpfnWndProc = &base_window_proc;
  window_base.cbClsExtra = window_base.cbWndExtra = 0;
  window_base.hInstance = inst;
  window_base.hIcon = LoadIconA(inst, tosjisz("FILE_ICON"));
  window_base.hCursor = LoadCursorA(null, IDC_ARROW);
  window_base.hbrBackground = cast(HBRUSH)(COLOR_WINDOW + 1);
  window_base.lpszMenuName = null;
  window_base.lpszClassName = tosjisz("MainWindow");
  return RegisterClassA(&window_base);
}

char[] read_ini(char[] filename, char[] base, char[] key, char[] rescue = ""){
  char[] buf = new char[256];
  int size = GetPrivateProfileStringA(base.tosjisz(), key.tosjisz(), rescue.tosjisz(), buf.ptr, 256, filename.tosjisz());
  return(buf.ptr[0..strlen(buf.ptr)]);
}
bool write_ini(char[] filename, char[] base, char[] key, char[] value){
  int result = WritePrivateProfileStringA(base.tosjisz(), key.tosjisz(), value.tosjisz(), filename.tosjisz());
  return(result != 0);
}

char[] tosjis(char[] str){return toString(std.windows.charset.toMBSz(str));}
char* tosjisz(char[] str){return std.windows.charset.toMBSz(str);}

char[] toutf(char[] str){return std.windows.charset.fromMBSz(str.toStringz());}
char* toutfz(char[] str){return std.windows.charset.fromMBSz(str.toStringz()).toStringz();}
